/* Name it "TagRead.java" 
 * TagǂݍރNX
 */
import javax.comm.*;
import java.util.*;
import java.io.*;

public class TagRead implements SerialPortEventListener{
	private static String memberFileName = "member.csv";
	private static String borrowFileName = "Borrow.csv";
	private static String logFileName = "RFIDLog.csv";
	private static String BorrowLogFileName = "BorrowLog.csv";
	
	private static MembersRead membersRead;
	private static BorrowRead borrowRead;
	private static OnUsersList onUsersList;
	private static Log rlog;
	private static Log blog;
	
	private TagReadCache tagReadCache = new TagReadCache();
	private Cal cal = new Cal();
	private Sound sound = new Sound();
	
	protected SerialPort port;
	
	protected BufferedInputStream comReader;
	protected BufferedOutputStream comWriter;
	
	protected BufferedReader sysReader;
	
	private Vector message = new Vector();
	
	String buffer, sbuffer;
	String ecode, tagNumber;
	
	int sflag = 0;
	
	//RXgN^
	public TagRead(){
		this.membersRead = new MembersRead(memberFileName);
		this.onUsersList = new OnUsersList(memberFileName, borrowFileName);
		this.borrowRead = new BorrowRead(borrowFileName);
		this.rlog = new Log(logFileName);
		this.blog = new Log(BorrowLogFileName);
		portSet();
		SendComand();
	}
	
	public TagRead(MembersRead membersRead, OnUsersList onUsersList, Log rlog, Log blog){
		this.membersRead = membersRead;
		this.onUsersList = onUsersList;
		this.borrowRead = new BorrowRead(borrowFileName);
		this.rlog = rlog;
		this.blog = blog;
		portSet();
		SendComand();
	}
	
	public void portSet(){
		//ʐM̐ݒ
		//super("COM1");
		CommPortIdentifier portID = null;
		
		try{
			// CommPortIdentifier 擾
			portID = CommPortIdentifier.getPortIdentifier("COM1");
		}catch(NoSuchPortException ex){
			ex.printStackTrace();
			System.exit(1);
		}
		
		try{
			// |[g̃I[v
			port = (SerialPort)portID.open("SerialPortWriter", 5000);
		}catch(PortInUseException ex){
			// ^CAEg߂ꍇ
			ex.printStackTrace();
			System.exit(1);
		}
		
		try {
			// ʐM̐ݒ
			port.setSerialPortParams(9600, // ʐMx 9600 baud
			SerialPort.DATABITS_8, // f[^rbg 8bit
			SerialPort.STOPBITS_1, // Xgbvrbg 1bit
			SerialPort.PARITY_EVEN); // peB 
			// t[Rg[̐ݒ
			port.setFlowControlMode(SerialPort.FLOWCONTROL_NONE);
		} catch (UnsupportedCommOperationException ex){
			ex.printStackTrace();
			System.exit(1);
		}
		
		try {
			// SerialPortEvent 󂯎邽߂̃Xi̓o^
			port.addEventListener(this);
		} catch(TooManyListenersException ex){
			ex.printStackTrace();
			System.exit(1);
		}
		
		// Data Available Cxg󂯎悤ɂ
		port.notifyOnDataAvailable(true);
		
		try {
			// RS-232C ͗p Reader 𐶐
			comReader = new BufferedInputStream(port.getInputStream());
			// RS-232C o͗p Writer 𐶐
			comWriter = new BufferedOutputStream(port.getOutputStream());
			
			// ͗p Reader 𐶐
			sysReader = new BufferedReader(new InputStreamReader(System.in));
		} catch (IOException ex){
			ex.printStackTrace();
			System.exit(1);
		}
	}
	
	public void close(){
		port.close();
	}
	
	public void SendComand(){
		try {
			//buffer = sysReader.readLine();
			buffer = "RDMRA10008";		//[hR}hi}`s[gAASCIIA1y[Wځj
			byte tx[] = {0x02, 0x30, 0x30, 0x03};
			byte h[] = buffer.getBytes();
			comWriter.write(tx, 0, 3);
			comWriter.write(h, 0, h.length);
			comWriter.write(tx, 3, 1);
			comWriter.flush();
			comWriter.close();
		} catch (IOException e){}
	}
	
	public void stop(){
		try {
			buffer = "ST1";		//StopR}h
			byte tx[] = {0x02, 0x30, 0x30, 0x03};
			byte h[] = buffer.getBytes();
			comWriter.write(tx, 0, 3);
			comWriter.write(h, 0, h.length);
			comWriter.write(tx, 3, 1);
			comWriter.flush();
			comWriter.close();
		} catch (IOException e){}
	}
	
	// Cxg[`
	public void serialEvent(SerialPortEvent event) {
		switch(event.getEventType()) {
	  		case SerialPortEvent.BI:
	 		case SerialPortEvent.OE:
	  		case SerialPortEvent.FE:
	  		case SerialPortEvent.PE:
	  		case SerialPortEvent.CD:
	  		case SerialPortEvent.CTS:
	  		case SerialPortEvent.DSR:
	 		case SerialPortEvent.RI:
	  		case SerialPortEvent.OUTPUT_BUFFER_EMPTY:
			// Data Available ȊÕCxg͏Ȃ
			break;
			case SerialPortEvent.DATA_AVAILABLE:
			// Data Available ̏
			byte bbuffer[] = new byte[17];
			try {
				int c;
				while ((c = comReader.read(bbuffer, 0, bbuffer.length)) != -1){
					// ^Õf[^̓ǂݍ
					sbuffer = new String(bbuffer);
					//System.out.println("> " + sbuffer);
					System.out.flush();
					//ڏt
					if(sbuffer.substring(1, 4).equals("000")){
						ecode = sbuffer.substring(1, 8);
						tagNumber = sbuffer.substring(8, 16);
					}else{
						tagNumber = sbuffer.substring(0, 8);
					}
					//m[}
					//ecode = sbuffer.substring(1, 8);
					//tagNumber = sbuffer.substring(8, 16);
					if(ecode.equals("000RD00") && tagNumber.length() != 0 && sflag == 1){
						userStatusCheck(tagNumber);
					}
					else if(ecode.equals("000RD72")){
						//ta.append("^OĉB");
						//ta.setCaretPosition(ta.getDocument().getLength());
					}
					else if(ecode.equals("000RD70")){
						//ta.append("ǂݎĂ܂B\nPx^OĉB");
						//ta.setCaretPosition(ta.getDocument().getLength());
					}
					sflag = 1;
				}
				comReader.close();
			} catch (IOException e){
			}
			break;
		}
	}
	
	public void userStatusCheck(String id) {
		try{
			int type = Integer.parseInt(id.substring(0, 1));
//ǉ
			if(id.equals("99999999")){
				sound.play(5);
			}else if(id.equals("88888888")){
				sound.play(4);
			}else
//܂
			if((membersRead.checkName(id) || borrowRead.checkName(id)) && tagReadCache.check(id)){
				tagReadCache.add(id);
				sound.play(2);
				if(type == 0){
					tagReadCache.addBorrow(id);
				}else{
					tagReadCache.addBorrower(id);
					UserStatusCheckThread uscThread = new UserStatusCheckThread(id);
					uscThread.start();
				}
				if(tagReadCache.checkBorrow() && tagReadCache.checkBorrower()){
					String borrow = tagReadCache.getBorrow();
					String Borrower = membersRead.getName(tagReadCache.getBorrower());
					if(onUsersList.checkBorrowMap(borrow)){
						onUsersList.removeBorrowMap(borrow);
						blog.write(borrow, Borrower, 0);
						addMessage(cal.date() + " " + cal.time() + " \r" + Borrower +" [" + borrowRead.getName(borrow) + "]ԋp܂I");
						sound.play(4);
					}else{
						onUsersList.putBorrowMap(borrow, Borrower);
						blog.write(borrow, Borrower, 1);
						addMessage(cal.date() + " " + cal.time() + " \r" + Borrower +" [" + borrowRead.getName(borrow) + "]؂܂I");
						sound.play(3);
					}
					tagReadCache.clearBorrower();
					System.out.println(id +" Borrow");
				}
			}
		}catch (Exception e){
		}
	}
	
	public class UserStatusCheckThread extends Thread {
		public UserStatusCheckThread(String name) {
    		super(name);
		}
		public void run() {
			try {
				sleep(1000);
			} catch (Exception e) {
			}
			if(tagReadCache.checkBorrower()){
				String id = this.getName();
				if(onUsersList.r_check(id)){
					onUsersList.r_remove(id);
					int size = onUsersList.r_size();
					rlog.write(id, 0, size);
					addMessage(cal.date() + " " + cal.time() + " \r" + membersRead.getName(id) +" 񂪑ގ܂B\r " + size + "lݎłI");
					System.out.println(id +" out");
					sound.play(1);
				}else{
					onUsersList.r_add(id, cal.date() + " " + cal.time());
					int size = onUsersList.r_size();
					rlog.write(id, 1, size);
					addMessage(cal.date() + " " + cal.time() + " \r" + membersRead.getName(id) +" 񂪓܂B\r " + size + "lݎłI");
					System.out.println(id +" in");
					sound.play(0);
				}
			onUsersList.r_print();
			}
		}
	}

	
	public void addMessage(String b){
		System.out.println(b);
		message.add(b);
		System.out.println(message.size());
	}
	
	public int messageSize(){
		return message.size();
	}
	
	public String getMessege(){
		String a = message.firstElement().toString();
		message.remove(0);
		return a;
	}
	
	public static void main(String[] argv){
		TagRead tr = new TagRead();
	}
}
